/* FormatUtils.c generated by valac 0.55.1, the Vala compiler
 * generated from FormatUtils.vala, do not modify */

/*
* Copyright (C) 2017-2021 Lains
*
* This program is free software; you can redistribute it &&/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	NOTEJOT_FORMAT_BOLD,
	NOTEJOT_FORMAT_ITALIC,
	NOTEJOT_FORMAT_UNDERLINE,
	NOTEJOT_FORMAT_STRIKETHROUGH
} NotejotFormat;

#define NOTEJOT_TYPE_FORMAT (notejot_format_get_type ())

#define NOTEJOT_TYPE_FORMAT_BLOCK (notejot_format_block_get_type ())
typedef struct _NotejotFormatBlock NotejotFormatBlock;

struct _NotejotFormatBlock {
	gint start;
	gint end;
	NotejotFormat format;
};

VALA_EXTERN GType notejot_format_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType notejot_format_block_get_type (void) G_GNUC_CONST ;
VALA_EXTERN NotejotFormatBlock* notejot_format_block_dup (const NotejotFormatBlock* self);
VALA_EXTERN void notejot_format_block_free (NotejotFormatBlock* self);
VALA_EXTERN gchar* notejot_format_to_string (NotejotFormat fmt);
VALA_EXTERN NotejotFormat notejot_string_to_format (const gchar* wrap);

static GType
notejot_format_get_type_once (void)
{
	static const GEnumValue values[] = {{NOTEJOT_FORMAT_BOLD, "NOTEJOT_FORMAT_BOLD", "bold"}, {NOTEJOT_FORMAT_ITALIC, "NOTEJOT_FORMAT_ITALIC", "italic"}, {NOTEJOT_FORMAT_UNDERLINE, "NOTEJOT_FORMAT_UNDERLINE", "underline"}, {NOTEJOT_FORMAT_STRIKETHROUGH, "NOTEJOT_FORMAT_STRIKETHROUGH", "strikethrough"}, {0, NULL, NULL}};
	GType notejot_format_type_id;
	notejot_format_type_id = g_enum_register_static ("NotejotFormat", values);
	return notejot_format_type_id;
}

GType
notejot_format_get_type (void)
{
	static volatile gsize notejot_format_type_id__once = 0;
	if (g_once_init_enter (&notejot_format_type_id__once)) {
		GType notejot_format_type_id;
		notejot_format_type_id = notejot_format_get_type_once ();
		g_once_init_leave (&notejot_format_type_id__once, notejot_format_type_id);
	}
	return notejot_format_type_id__once;
}

NotejotFormatBlock*
notejot_format_block_dup (const NotejotFormatBlock* self)
{
	NotejotFormatBlock* dup;
	dup = g_new0 (NotejotFormatBlock, 1);
	memcpy (dup, self, sizeof (NotejotFormatBlock));
	return dup;
}

void
notejot_format_block_free (NotejotFormatBlock* self)
{
	g_free (self);
}

static GType
notejot_format_block_get_type_once (void)
{
	GType notejot_format_block_type_id;
	notejot_format_block_type_id = g_boxed_type_register_static ("NotejotFormatBlock", (GBoxedCopyFunc) notejot_format_block_dup, (GBoxedFreeFunc) notejot_format_block_free);
	return notejot_format_block_type_id;
}

GType
notejot_format_block_get_type (void)
{
	static volatile gsize notejot_format_block_type_id__once = 0;
	if (g_once_init_enter (&notejot_format_block_type_id__once)) {
		GType notejot_format_block_type_id;
		notejot_format_block_type_id = notejot_format_block_get_type_once ();
		g_once_init_leave (&notejot_format_block_type_id__once, notejot_format_block_type_id);
	}
	return notejot_format_block_type_id__once;
}

gchar*
notejot_format_to_string (NotejotFormat fmt)
{
	gchar* result;
	switch (fmt) {
		case NOTEJOT_FORMAT_BOLD:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("|");
			result = _tmp0_;
			return result;
		}
		case NOTEJOT_FORMAT_ITALIC:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("*");
			result = _tmp1_;
			return result;
		}
		case NOTEJOT_FORMAT_UNDERLINE:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("_");
			result = _tmp2_;
			return result;
		}
		case NOTEJOT_FORMAT_STRIKETHROUGH:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("~");
			result = _tmp3_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

NotejotFormat
notejot_string_to_format (const gchar* wrap)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	NotejotFormat result;
	g_return_val_if_fail (wrap != NULL, 0);
	_tmp0_ = wrap;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("|")))) {
		switch (0) {
			default:
			{
				result = NOTEJOT_FORMAT_BOLD;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("*")))) {
		switch (0) {
			default:
			{
				result = NOTEJOT_FORMAT_ITALIC;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("_")))) {
		switch (0) {
			default:
			{
				result = NOTEJOT_FORMAT_UNDERLINE;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("~")))) {
		switch (0) {
			default:
			{
				result = NOTEJOT_FORMAT_STRIKETHROUGH;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_assert_not_reached ();
			}
		}
	}
}

